   import java.awt.*;
   import java.awt.event.*;
   import java.io.*;
   import javax.sound.sampled.*;

    class AudioTest extends Frame {
   
      private Button play;
      private Button loop;
      private Button stop;
      private Clip clip;
  
       public static void main ( String [] args ) {
      
         if (args.length == 1) {
            AudioTest test = new AudioTest( args[0] );
            test.show();
         } else {
         	System.out.println("Usage:  AudioTest audioFileName");
			}
      }
   
       public AudioTest (String audioFile) {
         setSize(400,100);
         setTitle("Audio Test Program");
         setLayout(new GridLayout(1, 3));
			
         play = new Button("Play");
         add(play);
         play.addActionListener( new ButtonListener() );
      
         loop = new Button("Loop");
         add(loop);
         loop.addActionListener( new ButtonListener() );
      
         stop = new Button("Stop");
         add(stop);
         stop.addActionListener( new ButtonListener() );
      
      
         try {
         // From file
            AudioInputStream stream = AudioSystem.getAudioInputStream(new File(audioFile));
         
         // From URL
         //        stream = AudioSystem.getAudioInputStream(new URL("http://hostname/audiofile"));
         
         // At present, ALAW and ULAW encodings must be converted
         // to PCM_SIGNED before it can be played
            AudioFormat format = stream.getFormat();
            if (format.getEncoding() != AudioFormat.Encoding.PCM_SIGNED) {
               format = new AudioFormat(
                  AudioFormat.Encoding.PCM_SIGNED,
                  format.getSampleRate(),
                  format.getSampleSizeInBits()*2,
                  format.getChannels(),
                  format.getFrameSize()*2,
                  format.getFrameRate(),
                  true);        // big endian
               stream = AudioSystem.getAudioInputStream(format, stream);
            }
         
         // Create the clip
            DataLine.Info info = new DataLine.Info(
               Clip.class, stream.getFormat(), 
               ((int)stream.getFrameLength()*format.getFrameSize()));
            clip = (Clip) AudioSystem.getLine(info);
         
         // This method does not return until the audio file is completely loaded
            clip.open(stream);
         }
             catch (UnsupportedAudioFileException ex) {
               System.out.println("Error: Unsupported");
            
            } 
             catch (Exception e) {
               System.out.println("Error in Audio stuff");
            }
      
      
      } // end AudioTest constructor
      
       private class ButtonListener implements ActionListener {
      
          public void actionPerformed( ActionEvent event ) {
         
            if (event.getSource() == play) {
            // Start playing
               System.out.println("clicked PLAY button: ");
               if (clip.isActive()) {
                  System.out.println("clip is active ");
               } 
               else {
                  System.out.println("clip is NOT active ");
               
               }
               clip.stop();
               clip.flush();
               clip.setFramePosition(0);
               clip.start();
            } 
            else 	if (event.getSource() == loop) {
               System.out.println("clicked LOOP button");
               clip.stop();
               clip.flush();
               clip.setFramePosition(0);
               clip.loop(Clip.LOOP_CONTINUOUSLY);
            } 
            else 	if (event.getSource() == stop) {
               System.out.println("clicked STOP button");
               clip.stop();
               clip.flush();
               clip.setFramePosition(0);
            //  clip.setLoopPoints(0,-1);
            } // end if
         
         } // end actionPerformed
      } // end class ButtonListener
   } // end class AudioTest